import java.io.InputStreamReader;
import java.io.IOException;
import java.util.Arrays;
import java.io.BufferedReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.util.StringTokenizer;
import java.io.InputStream;
 
/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class interactive_petr {
    public static void main(String[] args) {
        InputStream inputStream = System.in;
        OutputStream outputStream = System.out;
        InputReader in = new InputReader(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        Intercept solver = new Intercept();
        solver.solve(1, in, out);
        out.close();
    }
}
 
class Intercept {
    public void solve(int testNumber, InputReader in, PrintWriter out) {
        int p = in.nextInt();
        int v = in.nextInt();
        int[] min = new int[v + 1];
        int[] max = new int[v + 1];
        Arrays.fill(min, 0);
        Arrays.fill(max, p);
        for (int t = 0; t <= 100; ++t) {
            long total = 0;
            for (int i = 0; i <= v; ++i) if (min[i] <= max[i]) total += max[i] - min[i] + 1;
            if (total == 1) {
                for (int i = 0; i <= v; ++i) if (min[i] <= max[i]) {
                    out.println("answer " + (min[i] + i * t));
                    out.flush();
                    return;
                }
            }
            if (t == 100) throw new RuntimeException();
            int l = 0;
            int r = p + v * t + 1;
            while (r - l > 1) {
                int m = (l + r) / 2;
                long thistime = 0;
                for (int i = 0; i <= v; ++i) if (min[i] <= max[i]) {
                    int bound = (m - i * t);
                    if (bound > max[i])
                        thistime += 0;
                    else if (bound <= min[i])
                        thistime += max[i] - min[i] + 1;
                    else
                        thistime += max[i] - bound + 1;
                }
                if (thistime * 2 >= total) {
                    l = m;
                } else {
                    r = m;
                }
            }
            out.println("check " + l + " " + (p + v * t + 1));
            out.flush();
            String s = in.nextLine();
            if (s.equals("Yes")) {
                for (int i = 0; i <= v; ++i) if (min[i] <= max[i]) {
                    int bound = (l - i * t);
                    min[i] = Math.max(min[i], bound);
                }
            } else if (s.equals("No")) {
                for (int i = 0; i <= v; ++i) if (min[i] <= max[i]) {
                    int bound = (l - i * t);
                    max[i] = Math.min(max[i], bound - 1);
                }
            } else throw new RuntimeException();
        }
    }
}
 
class InputReader {
    public BufferedReader reader;
    public StringTokenizer tokenizer;
 
    public InputReader(InputStream stream) {
        reader = new BufferedReader(new InputStreamReader(stream));
        tokenizer = null;
    }
 
    public String next() {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            try {
                tokenizer = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }
        return tokenizer.nextToken();
    }
 
    public int nextInt() {
        return Integer.parseInt(next());
    }
 
    public String nextLine() {
        try {
            return reader.readLine();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }
 
    }